-- name: [CS] Sonic Randos
-- description: A collection of Sonic character mods I forgot to release until now     \\#ff7777\\This Pack requires Character Select\nto use as a Library!

local globalModName = "Sonic Randos"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_BLAZE_MODEL = smlua_model_util_get_id("blaze_geo") -- Located in "actors"
local E_BURG_MODEL = smlua_model_util_get_id("burg_geo") -- Located in "actors"
local E_CHAOS_MODEL = smlua_model_util_get_id("chaos_geo") -- Located in "actors"
local E_E102_MODEL = smlua_model_util_get_id("e102_geo") -- Located in "actors"
local E_NIGHTS_MODEL = smlua_model_util_get_id("nights_geo") -- Located in "actors"
local E_MODEL_WHISPER_MODEL = smlua_model_util_get_id("whisper_geo") -- Located in "actors"

local TEX_BLAZE_LIFE_ICON = get_texture_info("blaze_icon") -- Located in "textures"
local TEX_BURG_LIFE_ICON = get_texture_info("burg_icon") -- Located in "textures"
local TEX_CHAOS_LIFE_ICON = get_texture_info("chaos_icon") -- Located in "textures"
local TEX_E102_LIFE_ICON = get_texture_info("e102_icon") -- Located in "textures"
local TEX_NIGHTS_LIFE_ICON = get_texture_info("nights_icon") -- Located in "textures"
local TEX_WHISPER_LIFE_ICON = get_texture_info("whisper_icon") -- Located in "textures"

local VOICETABLE_BLAZE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'BlazeStartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'BlazeStartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'BlazeJump1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'BlazeJump2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'BlazeJump3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'BlazeJump1.ogg', 'BlazeJump2.ogg', 'BlazeJump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'BlazeDoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'BlazeTripleJump1.ogg', 'BlazeTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'BlazeBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'BlazeLaugh.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'BlazeJump2.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'BlazeClimb Ledge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'BlazeFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'BlazeTripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'BlazeGrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'BlazeGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'BlazeThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'BlazeDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'BlazeFalling.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'BlazeTired.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'BlazeTired.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'BlazeDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'BlazeDying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'BlazeBonk.ogg' -- Booted out of level
}

local VOICETABLE_BURG = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'BurgStartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'BurgStartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'BurgPunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'BurgPunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'BurgPunch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'BurgJump1.ogg', 'BurgJump2.ogg', 'BurgJump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'BurgDoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'BurgTripleJump1.ogg', 'BurgTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'BurgBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'BurgJump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'BurgGrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'BurgClimbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'BurgFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'BurgTwirl.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'BurgGrabLedge.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'BurgGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'BurgGetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'BurgDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'BurgPop.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'BurgFalling.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'BurgYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'BurgPop.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'BurgMumble.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'BurgPop.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Silent.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Silent.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'BurgLeaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_CHAOS = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'ChaosGetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'ChaosGetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'ChaosPunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'ChaosPunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'ChaosPunch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'ChaosJump1.ogg', 'ChaosJump2.ogg', 'ChaosJump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'ChaosDoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'ChaosTripleJump1.ogg', 'ChaosTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'ChaosBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'ChaosLongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'ChaosBonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'ChaosPunch2.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'ChaosFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'ChaosTripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'ChaosJump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'ChaosGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'ChaosGetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'ChaosDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'ChaosFalling.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'ChaosJump1.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'ChaosSnore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'ChaosMumble.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'ChaosJump1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'ChaosDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'ChaosDying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'ChaosBonk.ogg' -- Booted out of level
}

local VOICETABLE_E102 = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'E102StartGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'E102StartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'E102Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'E102Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'E102Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'E102Jump1.ogg', 'E102Jump1.ogg', 'E102Jump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'E102DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'E102TripleJump1.ogg', 'E102TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'E102Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'E102Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'E102Bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'E102ClimbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'E102Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'E102Jump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'E102GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'E102GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'E102ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'E102Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'E102Burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'E102Yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'E102Sleeptalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'E102Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'E102Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'E102LeaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_NIGHTS = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'NightsStartLevel', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'NightsStartLevel', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'NightsPunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'NightsPunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'NightsPunch1.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'NightsJump1.ogg', 'NightsJump2.ogg', 'NightsJump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'NightsDoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'NightsTripleJump1.ogg', 'NightsTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'NightsBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'NightsLandTripleJump.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'NightsJump2.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'NightsBonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'NightsClimbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'NightsFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'NightsTripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Silent.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'NightsStartLevel.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'NightsThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'NightsDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'NightsDamaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'NightsCough.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'NightsCough.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'NightsCough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'NightsDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'NightsDying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'NightsDamaged.ogg' -- Booted out of level
}

local VOICETABLE_WHISPER = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'whisperLevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'whisperLevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'whisperPunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'whisperPunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'whisperPunch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'whisperJump1.ogg', 'whisperJump2.ogg', 'whisperJump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Silent.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'whisperTripleJump1.ogg', 'whisperTripleJump1.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'whisperBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'whisperJump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Silent.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'whisperLedgeClimb.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'whisperJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'whisperLifting.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'whisperGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'whisperThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'whisperDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'whisperLowHealth.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'whisperBurned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'whisperYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'whisperSnore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'whisperCough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'whisperCough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'whisperCough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'whisperDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'whisperDrowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'whisperLeaveLevel.ogg' -- Booted out of level
}

local CAPTABLE_WHISPER = {
    normal = smlua_model_util_get_id("blaze_normal_geo"),
    wing = smlua_model_util_get_id("blaze_wing_geo"),
    metal = smlua_model_util_get_id("blaze_metal_geo"),
}

local CAPTABLE_CHAOS = {
    normal = smlua_model_util_get_id("blaze_normal_geo"),
    wing = smlua_model_util_get_id("blaze_wing_geo"),
    metal = smlua_model_util_get_id("blaze_metal_geo"),
}

local CAPTABLE_NIGHTS = {
    normal = smlua_model_util_get_id("blaze_normal_geo"),
    wing = smlua_model_util_get_id("blaze_wing_geo"),
    metal = smlua_model_util_get_id("blaze_metal_geo"),
}

local CAPTABLE_E102 = {
    normal = smlua_model_util_get_id("blaze_normal_geo"),
    wing = smlua_model_util_get_id("blaze_wing_geo"),
    metal = smlua_model_util_get_id("blaze_metal_geo"),
}

local CAPTABLE_BLAZE = {
    normal = smlua_model_util_get_id("blaze_normal_geo"),
    wing = smlua_model_util_get_id("blaze_wing_geo"),
    metal = smlua_model_util_get_id("blaze_metal_geo"),
}

local CAPTABLE_BURG = {
    normal = smlua_model_util_get_id("burgnormal_geo"),
    wing = smlua_model_util_get_id("burgwing_geo"),
    metal = smlua_model_util_get_id("burgmetal_geo"),
}

local PALETTE_BLAZE = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "CB0800",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FFA1D6",
    [CAP]    = "FFA1D6",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_BURG = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "C26A28",
    [GLOVES] = "ffffff",
    [SHOES]  = "330F00",
    [HAIR]   = "676767",
    [SKIN]   = "ffffff",
    [CAP]    = "D4AF37",
	[EMBLEM] = "184728",
}

local PALETTE_CHAOS = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "00C7FF",
    [CAP]    = "ffffff",
	[EMBLEM] = "5DFF6B",
}

local PALETTE_E102 = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "FFB52F",
    [SKIN]   = "FF0004",
    [CAP]    = "FF0004",
	[EMBLEM] = "00FF01"
}

local PALETTE_NIGHTS = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "24D974",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "723F31",
    [HAIR]   = "000000",
    [SKIN]   = "FEC179",
    [CAP]    = "FF2300",
    [EMBLEM]  = "1FA7FF",
}

local PALETTE_WHISPER = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "FFB26A",
    [CAP]    = "ffffff",
}

local HM_BLAZE= {
    label = {
        left = get_texture_info("tsonic1"),
        right = get_texture_info("tsonic2"),
    },
    pie = {
        [1] = get_texture_info("SPie1"),
        [2] = get_texture_info("SPie2"),
        [3] = get_texture_info("SPie3"),
        [4] = get_texture_info("SPie4"),
        [5] = get_texture_info("SPie5"),
        [6] = get_texture_info("SPie6"),
        [7] = get_texture_info("SPie7"),
        [8] = get_texture_info("SPie8"),
    }
}

local HM_BURG= {
    label = {
        left = get_texture_info("tsonic1"),
        right = get_texture_info("tsonic2"),
    },
    pie = {
        [1] = get_texture_info("SPie1"),
        [2] = get_texture_info("SPie2"),
        [3] = get_texture_info("SPie3"),
        [4] = get_texture_info("SPie4"),
        [5] = get_texture_info("SPie5"),
        [6] = get_texture_info("SPie6"),
        [7] = get_texture_info("SPie7"),
        [8] = get_texture_info("SPie8"),
    }
}

local HM_CHAOS= {
    label = {
        left = get_texture_info("tsonic1"),
        right = get_texture_info("tsonic2"),
    },
    pie = {
        [1] = get_texture_info("SPie1"),
        [2] = get_texture_info("SPie2"),
        [3] = get_texture_info("SPie3"),
        [4] = get_texture_info("SPie4"),
        [5] = get_texture_info("SPie5"),
        [6] = get_texture_info("SPie6"),
        [7] = get_texture_info("SPie7"),
        [8] = get_texture_info("SPie8"),
    }
}

local HM_E102= {
    label = {
        left = get_texture_info("tsonic1"),
        right = get_texture_info("tsonic2"),
    },
    pie = {
        [1] = get_texture_info("SPie1"),
        [2] = get_texture_info("SPie2"),
        [3] = get_texture_info("SPie3"),
        [4] = get_texture_info("SPie4"),
        [5] = get_texture_info("SPie5"),
        [6] = get_texture_info("SPie6"),
        [7] = get_texture_info("SPie7"),
        [8] = get_texture_info("SPie8"),
    }
}

local HM_WHISPER= {
    label = {
        left = get_texture_info("tsonic1"),
        right = get_texture_info("tsonic2"),
    },
    pie = {
        [1] = get_texture_info("SPie1"),
        [2] = get_texture_info("SPie2"),
        [3] = get_texture_info("SPie3"),
        [4] = get_texture_info("SPie4"),
        [5] = get_texture_info("SPie5"),
        [6] = get_texture_info("SPie6"),
        [7] = get_texture_info("SPie7"),
        [8] = get_texture_info("SPie8"),
    }
}

local HM_NIGHTS= {
    label = {
        left = get_texture_info("tsonic1"),
        right = get_texture_info("tsonic2"),
    },
    pie = {
        [1] = get_texture_info("SPie1"),
        [2] = get_texture_info("SPie2"),
        [3] = get_texture_info("SPie3"),
        [4] = get_texture_info("SPie4"),
        [5] = get_texture_info("SPie5"),
        [6] = get_texture_info("SPie6"),
        [7] = get_texture_info("SPie7"),
        [8] = get_texture_info("SPie8"),
    }
}

local CSloaded = false
local function on_character_select_load()
	
	CT_BLAZE = _G.charSelect.character_add("Blaze the Cat", {"The firey Princess of the Sol Dimension", "Model from Sonic Rush Adventure"}, "Garrulous64", {r = 252, g = 139, b = 255}, E_BLAZE_MODEL, CT_BLAZE, TEX_BLAZE_LIFE_ICON)
    _G.charSelect.character_add_voice(E_BLAZE_MODEL, VOICETABLE_BLAZE)
    _G.charSelect.character_add_palette_preset(E_BLAZE_MODEL, PALETTE_BLAZE)
	_G.charSelect.character_add_caps(E_BLAZE_MODEL, CAPTABLE_BLAZE)
	_G.charSelect.character_add_health_meter(CT_BLAZE, HM_BLAZE)

    CT_BURG = _G.charSelect.character_add("Burger Man", {"The Mascot of All Time.", "Model from Sonic Adventure"}, "Garrulous64", {r = 138, g = 80, b = 65}, E_BURG_MODEL, CT_BURG, TEX_BURG_LIFE_ICON)
    _G.charSelect.character_add_voice(E_BURG_MODEL, VOICETABLE_BURG)
    _G.charSelect.character_add_palette_preset(E_BURG_MODEL, PALETTE_BURG)
	_G.charSelect.character_add_caps(E_BURG_MODEL, CAPTABLE_BURG)
	_G.charSelect.character_add_health_meter(CT_BURG, HM_BURG)

    CT_CHAOS = _G.charSelect.character_add("Chaos 0", {"The GOD of Destruction!", "Model from Sonic Adventure"}, "Garrulous64", {r = 0, g = 100, b = 255}, E_CHAOS_MODEL, CT_CHAOS, TEX_CHAOS_LIFE_ICON)
    _G.charSelect.character_add_voice(E_CHAOS_MODEL, VOICETABLE_CHAOS)
	_G.charSelect.character_add_caps(E_CHAOS_MODEL, CAPTABLE_CHAOS)
    _G.charSelect.character_add_palette_preset(E_CHAOS_MODEL, PALETTE_CHAOS)
	_G.charSelect.character_add_health_meter(CT_CHAOS, HM_CHAOS)
	
	CT_NIGHTS = _G.charSelect.character_add("NiGHTS", {"Your BEST Nightmare!", "Model from NiGHTS Into Dreams"}, "Garrulous64", {r = 125, g = 0, b = 255}, E_NIGHTS_MODEL, CT_NIGHTS, TEX_NIGHTS_LIFE_ICON)
    _G.charSelect.character_add_voice(E_NIGHTS_MODEL, VOICETABLE_NIGHTS)
    _G.charSelect.character_add_palette_preset(E_NIGHTS_MODEL, PALETTE_NIGHTS)
	_G.charSelect.character_add_caps(E_NIGHTS_MODEL, CAPTABLE_NIGHTS)
	_G.charSelect.character_add_health_meter(CT_NIGHTS, HM_NIGHTS)
	
	CT_E102 = _G.charSelect.character_add("E-102 Gamma", {"The Original Rebellious Robot.", "Model from Sonic Shuffle"}, "Garrulous64", {r = 255, g = 0, b = 0}, E_E102_MODEL, CT_E102, TEX_E102_LIFE_ICON)
    _G.charSelect.character_add_voice(E_E102_MODEL, VOICETABLE_E102)
    _G.charSelect.character_add_palette_preset(E_E102_MODEL, PALETTE_E102)
	_G.charSelect.character_add_caps(E_E102_MODEL, CAPTABLE_E102)
	_G.charSelect.character_add_health_meter(CT_E102, HM_E102)
	
	CT_WHISPER = _G.charSelect.character_add("Whisper the Wolf", {"Guardian Angel of the Restoration.", "Custom Model by: TDRR, Voice by: CutieMonica"}, "Garrulous64", {r = 212, g = 243, b = 12}, E_MODEL_WHISPER_MODEL, CT_WHISPER, TEX_WHISPER_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_WHISPER_MODEL, CAPTABLE_WHISPER)
    _G.charSelect.character_add_voice(E_MODEL_WHISPER_MODEL, VOICETABLE_WHISPER)
    _G.charSelect.character_add_palette_preset(E_MODEL_WHISPER_MODEL, PALETTE_WHISPER)
	_G.charSelect.character_add_health_meter(CT_WHISPER, HM_WHISPER)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BLAZE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_E102 then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAOS then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_BURG then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_NIGHTS then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_WHISPER then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DEDEDE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TARANZA then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_CHEFK then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TAC then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ROCKY then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_KJOE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_BONKERS then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DAROACH then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MAGOLOR then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ESCARGOON then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BLAZE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAOS then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_BURG then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_E102 then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_NIGHTS then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_WHISPER then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DEDEDE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TARANZA then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_CHEFK then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TAC then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ROCKY then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_KJOE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_BONKERS then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DAROACH then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MAGOLOR then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ESCARGOON then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)